﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Math.Calculators;
namespace MathCalculatorsDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
    }
    //Define a Custom Calculator
    /// <summary>
    /// Calculates the Index of dispersion of set of data.
    /// </summary>
    /// <param name="input"> The input list of double values.</param>
    public class IndexDispersionCalculator : ValueCalculator
    {
        public override double Calculate(System.Collections.Generic.IList<double> input)
        {
            VarianceCalculator _variance = new VarianceCalculator();
            MeanCalculator _mean = new MeanCalculator();
            double result;
            if (_mean.Calculate(input) == double.NaN)
            {
                return double.NaN;
            }
            else
            {
                result = _variance.Calculate(input) / _mean.Calculate(input);
            }
            return result;
        }
    }
    
    #region Sample Data
    public class DataPointSample : DataPointCollection
    {
        public DataPointSample()
        {
            _settings = new DataPointSettings
            {
                DataPoints = 100,
                Min = 0,
                Max = 100,
            };
            this.GenerateRandomData();
        }
        
        protected void GenerateRandomData()
        {
            this.Clear();
            for (int i = 0; i < this.Settings.DataPoints; i++)
            {
                double x = DataPointGenerator.Random.Next(this.Settings.Min, this.Settings.Max);
                this.Add(new DataPoint { Value = x});
            }
        }
        
        #region Properties
        private DataPointSettings _settings;
        public DataPointSettings Settings
        {
            get { return _settings; }
            set
            {
                if (_settings == value) return;
                _settings = value;
                this.GenerateRandomData();
            }
        }
        #endregion
    }

    public static class DataPointGenerator
    {
        public static Random Random = new Random();
    }
    public class DataPointSettings
    {
        public DataPointSettings()
        {
            DataPoints = 100;
            Min = 5;
            Max = 1000;
        }

        #region Properties

        public int DataPoints { get; set; }

        public int Min { get; set; }

        public int Max { get; set; }

        #endregion


    }
    public class DataPointCollection : ObservableCollection<DataPoint> { }

    public class DataPoint
    {
        public double Value { get; set; }
    }
    #endregion
}
